#include <iostream>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <inttypes.h>        // uint64_t
#include <unistd.h>          // usleep
#include "globals.h"

#include <rtai_lxrt.h>
#include <sys/mman.h>

#ifndef __CONTROL_LOOP_H__
#define __CONTROL_LOOP_H__

using namespace std;

enum CONTROLLOOP_STATE{CONTROLLOOP_STOP, CONTROLLOOP_RUN};

class ControlLoop{
private:
  pthread_t ctrlthread;
  pthread_mutex_t mutex;
  CONTROLLOOP_STATE cls;

public:
  //static const double PERIOD = 0.01;
  //static const double PERIOD = 0.002;
  static const double PERIOD = 0.002;

  void* (*ctrl_fnc)(void*);
  void* ctrl_argv;

  void lock(){pthread_mutex_lock(&mutex);}
  void unlock(){pthread_mutex_unlock(&mutex);}

  ControlLoop();
  
  int start(void* ctrl_fnc(void*), void* argv);
  int stop();
  int state();
  void wait();
};

#endif

