
/*
 * This is really just very basic interface that provides a state and a mutex
 * This class is used to derive SE3 controllers and joint controllers
 */

#ifndef __CONTROLLER_HH__
#define __CONTROLLER_HH__

class Controller{

private:
  pthread_mutex_t mutex;
  int s;

public:

  static const int STOP = 0;
  static const int RUN  = 1;

  Controller(){
    pthread_mutex_init(&mutex, NULL); 
    stop();
  }

  void lock()  {pthread_mutex_lock  (&mutex);}
  void unlock(){pthread_mutex_unlock(&mutex);}

  void run(){   lock();  s = Controller::RUN;   unlock();  }
  void stop(){  lock();  s = Controller::STOP;  unlock();  }

  int state(){
    int S;
    lock();
    S = s;
    unlock();
    return S;
  }
};

#endif
