#include "Joint.hh"

#include <openmath/SE3.hh>
#include <openmath/R6.hh>

#include <mkl_lapack.h>
#include <mkl_blas.h>

#include "Kinematics.hh"

#ifndef __DYNAMICS_HH__
#define __DYNAMICS_HH__

void RNE(double* tau, Link* links, double* qd, double* qdd, R6& fext);
void CCG(double* ccg, Link* links, double* qd);

R6 bias_acceleration(Link* links, double *qd);
R6      acceleration(Link* links, double *qd, double* qdd);

void WSinertia(double A[6][6],               Link* links);
void JSinertia(double A[Link::Ln][Link::Ln], Link* links);

void WSdynamics(double* trq, Link* links, double* qd, R6& F);
void JSdynamics(double* trq, Link* links, double* qd, double* qdd);

#endif
