#include "Controller.hh"

#ifndef __JOINTCTRL_HH__
#define __JOINTCTRL_HH__

/*
 * This is just an interface
 * Derive this class (PD, PID joint controllers) and you can point to it to 
 * control the WAM
 */

class JointCtrl : public Controller{
protected:
  double qref;    // not really used during motion
                  // mostly used when idle
public:

  JointCtrl() : Controller() {}

  virtual double evaluate(double qs, double q, double dt) = 0;
  virtual void set(double qref) = 0;
  virtual void reset() = 0;

  // lil hack to read the subclass
  virtual ostream& put(ostream& s){return s;}
  virtual istream& get(istream& s){return s;}

  friend istream& operator >> (istream& s, JointCtrl& jctrl){
    return jctrl.get(s);
  }
  friend ostream& operator << (ostream& s, JointCtrl& jctrl){
    return jctrl.put(s);
  }

};

#endif
