#include "Kinematics.hh"

SE3 forward_kinematics(Link* link){
  SE3 H = (SE3)link[Link::L0];

  for(int l=Link::L1; l<=Link::Ln; l++)
    H = H * (SE3)link[l];

  return H;
}

/*
 * Body manipulator Jacobian
 * Paul IEEE SMC 11(6) 1981
 * 
 * BIG FAT FUCKIN' WARNIN': The jacobian is in column major (for Fortran)
 */

void JacobianNF(double J[][6], Link *links){
  SE3 U;

  for(int l=Link::Ln; Link::L1<=l; l--){
    U = ((SE3)links[l]) * U;

    J[l-1][0] = U[SE3::TX]*U[SE3::NY] - U[SE3::TY]*U[SE3::NX];
    J[l-1][1] = U[SE3::TX]*U[SE3::OY] - U[SE3::TY]*U[SE3::OX];
    J[l-1][2] = U[SE3::TX]*U[SE3::AY] - U[SE3::TY]*U[SE3::AX];
    J[l-1][3] = U[SE3::NZ];
    J[l-1][4] = U[SE3::OZ];
    J[l-1][5] = U[SE3::AZ];
  }
}

void JacobianN(double J[][7], Link *links){
  SE3 U;

  for(int l=Link::Ln; Link::L1<=l; l--){
    U = ((SE3)links[l]) * U;

    J[0][l-1] = U[SE3::TX]*U[SE3::NY] - U[SE3::TY]*U[SE3::NX];
    J[1][l-1] = U[SE3::TX]*U[SE3::OY] - U[SE3::TY]*U[SE3::OX];
    J[2][l-1] = U[SE3::TX]*U[SE3::AY] - U[SE3::TY]*U[SE3::AX];
    J[3][l-1] = U[SE3::NZ];
    J[4][l-1] = U[SE3::OZ];
    J[5][l-1] = U[SE3::AZ];
  }
}
