#include <iomanip>
#include <mathimf.h>

#include "Controller.hh"

#ifndef __PID_HH__
#define __PID_HH__

using namespace std;

# define sign(x) (x>=0?1:-1)

class PID : public Controller{
private:
  
  double Kp, Kd, Ki;
  double saturation; // Defaults to zero (doesn't ever saturate)
   
  double laste;
  double se;         // Sum of error
   
  int firsttick;     // handles special case de for first tick
   
public:

  PID();
  ~PID(){}

  // virtual interface
  void set(double qref);
  void reset(double qref);
  double evaluate(double q, double dt);
  
  void KpKdKi(double kp, double kd, double ki){Kp=kp;Kd=kd;Ki=ki;}

  istream& get(istream& s);
  ostream& put(ostream& s);
};

#endif 
