#include <iostream>
#include "globals.h"

#ifndef __PUCK_H__
#define __PUCK_H__

using namespace std;

#define PUCK_ORDER_MIN 1
#define PUCK_ORDER_MAX 4
#define NUM_ORDERS     (PUCK_ORDER_MAX - PUCK_ORDER_MIN + 1)

enum{STATUS_OFFLINE = -1,
     STATUS_RESET,
     STATUS_ERR,
     STATUS_READY
};

class Puck{
 private:
   int IoffsetB;         // Offset to calibrate zero for current sensors
   int IoffsetC;         // Offset to calibrate zero for current sensors

   int ID;
   int group_id;
   int group_order; 
   int motor_id;   
   int cpr;             // Encoder counts per revolution

 public:

  static const int MIN_TRQ[];
  static const int MAX_TRQ[];
  
  Puck(){ID=-1;}
  
  int id(){return ID;}
  int group(){return group_id;}
  int order(){return group_order;}
  int motor(){return motor_id;}
  int CPR(){return cpr;}
  
  friend istream& operator >> (istream& s, Puck& p){
    s >> p.ID
      >> p.motor_id
      >> p.group_id
      >> p.group_order
      >> p.IoffsetB
      >> p.IoffsetC
      >> p.cpr;
    return s;
  }

  friend ostream& operator << (ostream& s, Puck& p){
    s << "Puck (id#): "     << p.id()     << "; "
      << "Motor#: "         << p.motor()  << "; "
      << "Group (id#): "    << p.group()  << "; "
      << "Group (order#): " << p.order()  << "; "
      << "IoffsetB: "       << p.IoffsetB << "; "
      << "IoffsetC: "       << p.IoffsetC << "; "
      << "Counts/Rev: "     << p.cpr;
    return s;
  }
}; 

#endif
