#include "Controller.hh"
#include <openmath/SE3.hh>

#ifndef __SE3CTRL_HH__
#define __SE3CTRL_HH__

/*
 * This is just an interface that explain how a SE3 controller must work
 * Derive this class and you can point to it to control the WAM
 */

class SE3Ctrl : public Controller{
protected:
  SE3 se3ref;    // not really used during a motion
                 // mostly used during when idle
public:

  SE3Ctrl() : Controller() {}

  void set(const SE3& se3){  lock();  se3ref=se3;  unlock();  }

  virtual R6 evaluate(const SE3& E0s, const SE3& E0n, double dt) = 0;
  virtual void reset() = 0;

};

#endif
